Package com.google.javascript.rhino.jstype

# Class Property

java.lang.Object
com.google.javascript.rhino.jstype.Property

All Implemented Interfaces:
  `StaticReference<JSType>`, `StaticSlot<JSType>`, `Serializable`

public final class Property extends Object implements Serializable, StaticSlot<JSType>, StaticReference<JSType>
A property slot of an object.

See Also:
  - Serialized Form

## Method Summary

Modifier and Type
Method
Description
`Property`
`getDeclaration()`
Gets the declaration of this symbol.
`JSDocInfo`
`getJSDocInfo()`
Gets the JSDoc for this slot.
`String`
`getName()`
Gets the name of the slot.
`Node`
`getNode()`
The node where the reference lives.
`StaticSourceFile`
`getSourceFile()`
The source file where the reference lives.
`Property`
`getSymbol()`
The variable that this reference points to.
`JSType`
`getType()`
Returns the type information, if any, for this slot.
`boolean`
`isTypeInferred()`
Returns whether the type has been inferred (as opposed to declared).
`void`
`setNode(Node n)`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Method Details

### getName

public String getName()
Description copied from interface: `StaticSlot`
Gets the name of the slot.

Specified by:
  `getName` in interface `StaticSlot<JSType>`

### getNode

public Node getNode()
Description copied from interface: `StaticReference`
The node where the reference lives.

Specified by:
  `getNode` in interface `StaticReference<JSType>`

### getSourceFile

public StaticSourceFile getSourceFile()
Description copied from interface: `StaticReference`
The source file where the reference lives.

Specified by:
  `getSourceFile` in interface `StaticReference<JSType>`

### getSymbol

public Property getSymbol()
Description copied from interface: `StaticReference`
The variable that this reference points to.

Specified by:
  `getSymbol` in interface `StaticReference<JSType>`

### getDeclaration

public Property getDeclaration()
Description copied from interface: `StaticSlot`
Gets the declaration of this symbol. May not exist.

Specified by:
  `getDeclaration` in interface `StaticSlot<JSType>`

### getType

public JSType getType()
Description copied from interface: `StaticSlot`
Returns the type information, if any, for this slot.

Specified by:
  `getType` in interface `StaticSlot<JSType>`
Returns:
  The type or `null` if no type is declared for it.

### isTypeInferred

public boolean isTypeInferred()
Description copied from interface: `StaticSlot`
Returns whether the type has been inferred (as opposed to declared).

Specified by:
  `isTypeInferred` in interface `StaticSlot<JSType>`

### getJSDocInfo

public JSDocInfo getJSDocInfo()
Description copied from interface: `StaticSlot`
Gets the JSDoc for this slot.

Specified by:
  `getJSDocInfo` in interface `StaticSlot<JSType>`

### setNode

public void setNode(Node n)